
TextWindow subclass: #DDETestClient
  instanceVariableNames: 
    'dde arch mat l c n '
  classVariableNames: ''
  poolDictionaries: 
    'WinConstants '    !


!DDETestClient class methods ! !



!DDETestClient methods !
 
abrir
  |alix|
          ( alix := DDEClient newClient: self application: 'Excel' topic: 'Libro1' ) isNil ifTrue:
    [MessageBox titled: 'Advertencia'  withText: 'No puede inicializarse con el servidor' style: MbOk|MbIconexclamation.
        ^false].
       alix pokeItem: 'L4C3' object: 'BIENVENIDO A MONITOREO'.
       arch := Prompter prompt: 'De nombre de archivo en Excel para abrir, especificando directorio.' default: ''.
      (alix executeCommand: '[Abrir("',arch,'")]' ).
      "ifFalse:[MessageBox message: 'El comando fue ejecutado exitosamente por Excel'].  "
       alix terminate.!
  
cerrar
(MessageBox confirm: 'Salir de monitoreo')
          ifTrue: [dde notNil ifTrue: [dde terminate].
                      super close.
                     ].!

close
(MessageBox confirm: 'Salir de monitoreo')
          ifTrue: [dde notNil ifTrue: [dde executeCommand: '[Cerrar]';
                                                           terminate].
                      super close.
                     ].!
 
close: aPane
    "Close the window and terminate DDE"

 (MessageBox confirm: 'Salir de monitoreo')
          ifTrue: [dde notNil ifTrue: [ dde executeCommand: '[Cerrar]';
                                                    terminate].
                      super close.
                     ].!
   
compara
 | i j cad1 cad2 stream1 stream2 s t|
       i:=1.   j:=1.
     [i <= l]
             whileTrue: [
                   cad1:= mat atRow:i  atColumn:j.
                   cad2:= n atRow:i atColumn:j.
                   stream1:= WriteStream on: ''.
                    i printOn: stream1.
                    s:='L', stream1 contents.
                    stream2 := WriteStream on: ''.
                    j printOn: stream2.
                    t:='C', stream2 contents.
                    (cad1 equals: cad2)
                           ifFalse: [MessageBox notify: 'Mensaje para usuario'  withText: 'La celda  ', s,t, '  ', 'sufri cambios'.
                                          self scan: cad1 to: cad2 ].
                   ( j = c)
                       ifTrue: [ j:=1.
                                    i:=i+1]
                       ifFalse: [ j:= j+1].
                                 ]!
 
cuenta
     | i j cad1 cad2 a stream1 x|
  a:=0.   i:=1.
   j:=1.
 [i <= l]
             whileTrue: [
                   cad1:= mat atRow:i  atColumn:j.
                   cad2:= n atRow:i atColumn:j.
                    (cad1 equals: cad2)
                          ifFalse: [a:= a+1].
                     ( j = c)
                       ifTrue: [ j:=1.
                                    i:=i+1]
                       ifFalse: [ j:= j+1].
                                 ].
     x:= (l * c).
     (x = a)
      ifTrue: [  MessageBox notify: 'Mensaje para usuario'  withText: 'No hubo modificaciones'.
                    a:=0. self cerrar].
     stream1 := WriteStream on: ''.
     a printOn: stream1.
     MessageBox notify: 'Mensaje para usuario'  withText: '       ',stream1 contents,'   ', 'modificaciones'.!
 
dde

    "Answers the current DDE instance variable."

    ^dde.!
   
despliega

       | string s t  stream stream2 dato v1 i j |

   i:=1.
   j:=1.
   c := (Prompter prompt: 'De cuantas columnas consta la hoja ' default: '') asInteger.
   l :=  (Prompter prompt: 'De cuantos renglones consta la hoja ' default: '') asInteger.
    mat:= (Matriz rows: l columns: c).
    n:= (Matriz rows: l columns: c).
       [ i <= l]
    whileTrue: [
                   j:=1.
                   stream := WriteStream on: ''.
                   i printOn: stream.
                   s:='L', stream contents.
                   [ j<= c]
                   whileTrue: [ stream2 := WriteStream on: ''.
                                            j printOn: stream2.
                                            t:='C', stream2 contents.
                                            string := s,t.
                                            dato := dde requestItem: string class: String.
                                            mat atRow: i atColumn: j putData: dato.
                                            dde hotLinkItem: string class: String selector:#item:string:.
                                            j := j+1
                                         ].
                                    i := i+1
                   ].

      self show: '         '.   self cr.
      self show: '          '.  self cr.   self cr. self cr.
      self show: '       Se est monitoreando el archivo:  ', arch.!
 
formu
      |new|
     (MessageBox confirm: 'Desea monitorear las frmulas?')
        ifTrue: [new:= DDEClient newClient: self application: 'Excel' topic: arch.
                    (new executeCommand: '[Ejecutar("PERSONAL.XLS!!formulas")]').
                     new terminate].!
   
informa

        "Mtodo con informacin sobre el sistema"

    MessageBox titled: 'Sistema de Monitoreo'  withText: 'Sistema elaborado por Alicia Pineda Ramirez.  1997'  style: MbOk|MbIconexclamation.!
  
initiate: application topic: topic

    "Initiate DDE session"

    (dde := DDEClient newClient: self
                   application: application
                   topic: topic) isNil ifTrue:
    [
        MessageBox titled: 'warning'  withText: 'Couldn''t Initiate with server' style: MbOk|MbIconexclamation.
        ^false
    ]!
  
item: item string2: string

    "The server has updated a hot linked item."

      self show:item; show:'     ';  show:string.!
 
item: item string: string

    "The server has updated a hot linked item."
            |ren col |
        col:=((item reversed upTo: $C) reversed) asInteger.
        ren:=((item  upTo:$C) copyWithout: $L) asInteger.
          n atRow: ren atColumn: col putData: string.!

openExcel

        "Open a DDE Excel client"

    super openOn: ' '.
    self mainView when:#close perform:#close:.
    self abrir;
           formu;
           initiate: 'Excel' topic: arch;
          despliega.!
  
scan: cad1 to: cad2

         | ele1 ele2 men |
        ele1:= cad1 first.   ele2:= cad2 first.
        (ele1 ~= $= and: [ele2 ~= $=])
            ifTrue: [MessageBox notify: 'Mensaje para usuario'  withText:'El contenido de la celda ha cambiado'].
        (ele1 = $= and: [ele2 ~= $=])
            ifTrue: [MessageBox notify: 'Mensaje para usuario'  withText:'Se tena una frmula, se ha cambiado por un texto'].
        (ele1 ~= $= and: [ele2 = $=])
            ifTrue: [MessageBox notify: 'Mensaje para usuario'  withText:'Se tena un texto, se ha cambiado por una frmula'].
        (ele1 = $= and: [ele2 = $=])
            ifTrue: [MessageBox notify: 'Mensaje para usuario'  withText:'La frmula ha cambiado'].! !
